
#include <zephyr.h>
#include <bsd.h>
#include <nrf_socket.h>
#include <net/socket.h>
#include <stdio.h>

#include <misc/reboot.h>
#include <device.h>
#include <string.h>
#include <flash.h>
#include <nvs/nvs.h>

#ifndef _GPS__H_
#define _GPS__H_

#define GPS_IDLE 0
#define RECORD_COORDINATE 1
#define GET_FIX 2

#define FIX_PING_RATE 500

//---Library defs

int init_app(void);

int close_app(int socket);

//void print_satellite_stats(nrf_gnss_data_frame_t *pvt_data);

//void print_pvt_data(nrf_gnss_data_frame_t *pvt_data);

//void print_nmea_data(void);

//int process_gps_data(nrf_gnss_data_frame_t *gps_data);


//---New defs

struct coordinate_data {
    double latitude;
    double longitude;
    float accuracy;
    unsigned long timestamp;
};

void GPS_Init();

int GPS_Enable();

int GPS_Disable();

s64_t GPS_Update_Rate(s64_t new_rate);

double Get_Lat(struct nvs_fs* fs);

double Get_Lon(struct nvs_fs* fs);

unsigned long Get_Time(struct nvs_fs* fs);

int Get_Loc_ID();

void GPS_Logging_On();

void GPS_Logging_Off();

bool GPS_Is_Logging();

void UART_Output_On();

void UART_Output_Off();

void GPS_State_Machine(struct nvs_fs* fs);

void spoof(bool set);

struct coordinate_data make_coord_struct(struct nvs_fs* fs, int id);

void make_coord_json_string(char* out, struct nvs_fs* fs, int id);

void make_coordinate_struct_array(struct nvs_fs* fs, struct coordinate_data* out);

char* make_coord_array_json_string(char* out, struct coordinate_data* array, int size);

#endif